#include <SPI.h>

#include <TFT.h>

#define cs 10
#define dc 9
#define rst 8

TFT TFTScreen = TFT(cs,dc,rst);

int up_buttonState = 0, prev_up = 0;
int down_buttonState = 0, prev_down = 0;
int left_buttonState = 0, prev_left = 0;
int right_buttonState = 0, prev_right = 0;
int X_buttonState = 0, prev_X = 0;
int O_buttonState = 0, prev_O = 0;

int cursor_x = 20, cursor_y = 20;
int cursor_x2 = 10, cursor_y2 = 10;
int i = 0, j = 0, contor = 0;
int winner_x = 0, winner_o = 0;
bool is_full = false;

volatile int c = 0;
volatile unsigned long timer = 0;

byte a[][3] = { 
  {0,0,0},
  {0,0,0},
  {0,0,0}
};

int check_game_over() {
  for(int k = 0; k < 3; k++) {
    if(a[k][0] == 1 && a[k][1] == 1 && a[k][2] == 1)
      return 1; //O wins
    if(a[k][0] == 2 && a[k][1] == 2 && a[k][2] == 2)
      return 2; //X wins
  }

  for(int k = 0; k < 3; k++) {
    if(a[0][k] == 1 && a[1][k] == 1 && a[2][k] == 1)
      return 1; //O wins
    if(a[0][k] == 2 && a[1][k] == 2 && a[2][k] == 2)
      return 2; //X wins  
  }

  if(a[0][0] == 1 && a[1][1] == 1 && a[2][2] == 1)      
    return 1; //O wins
  if (a[2][0] == 1 && a[1][1] == 1 && a[0][2] == 1) 
    return 1; //O wins
  if(a[0][0] == 2 && a[1][1] == 2 && a[2][2] == 2)      
    return 2; //X wins  
  if (a[2][0] == 2 && a[1][1] == 2 && a[0][2] == 2)
    return 2; //X wins
  return 0;    
}

void reset_game() {
  delay(3000);

  /* fills display with black */
  TFTScreen.background(0,0,0);

  /* initial matrix */
  TFTScreen.stroke(255,0,0); //blue
  TFTScreen.rect(10,10,90,90);
  TFTScreen.rect(40,10,0,90);
  TFTScreen.rect(70,10,0,90);
  TFTScreen.rect(10,40,90,0);
  TFTScreen.rect(10,70,90,0);

  /* initial position */
  TFTScreen.stroke(255,255,255); //white
  TFTScreen.rect(10,10,30,30);

  for(int k = 0; k < 3; k++)
    for(int h = 0; h < 3; h++)
      a[k][h] = 0;

  TFTScreen.stroke(0,0,255); // red
  TFTScreen.setCursor(115, 50);
  TFTScreen.setTextSize(2);
  TFTScreen.println(winner_o);
  TFTScreen.stroke(0,255,255); // yellow
  TFTScreen.setCursor(115, 80);
  TFTScreen.setTextSize(2);
  TFTScreen.println(winner_x);    

  i = 0;
  j = 0;
  cursor_x = 20;
  cursor_y = 20;
  cursor_x2 = 10;
  cursor_y2 = 10; 
  contor = 0; 
  c = 0;
  is_full = false;
}

void reset_display() {
  int x = 10, y = 10;
  for(int k = 0; k < 3; k++) { 
    y = 10;
    for(int h = 0; h < 3; h++) {
      TFTScreen.stroke(255,0,0); //blue
      TFTScreen.rect(x,y,30,30);
      y += 30;
    }
    x += 30;
  }
}

void myCallback() {
  delay(2000);
  if(contor == 9)
    is_full = true;
  //contor += 1;
  //Serial.println(contor);
}

void show_timer() {
  TFTScreen.stroke(0,0,0); // black
  TFTScreen.rect(105,10,40,30);
  TFTScreen.fillRect(105,10,40,30,0x0000);
  TFTScreen.stroke(255,255,255); // red
  TFTScreen.setCursor(115, 20);
  TFTScreen.setTextSize(2);
  TFTScreen.println(c);
}

ISR(TIMER1_COMPA_vect) {
  c++;
  show_timer();
  if (c >= 45) {
    TFTScreen.background(0,0,0);
    TFTScreen.stroke(255,255,255); // white
    TFTScreen.setCursor(20, 0);
    TFTScreen.setTextSize(2);
    TFTScreen.println("TIME'S UP!");
    reset_game(); 
    c = 0;
  }
}

void setup() {
  pinMode(6, INPUT_PULLUP);
  pinMode(7, INPUT_PULLUP);
  pinMode(4, INPUT_PULLUP);
  pinMode(5, INPUT_PULLUP);
  pinMode(3, INPUT_PULLUP);
  pinMode(2, INPUT_PULLUP);
  /* digitalPinToInterrupt() returneaza numarul intreruperii asociate pinului */
  attachInterrupt(digitalPinToInterrupt(2), myCallback, FALLING);
  attachInterrupt(digitalPinToInterrupt(3), myCallback, FALLING);

  Serial.begin(9600);

  /* starts the library */
  TFTScreen.begin(); 
  /* fills display with black */
  TFTScreen.background(0,0,0);

  /* initial matrix */
  TFTScreen.stroke(255,0,0); //blue
  TFTScreen.rect(10,10,90,90);
  TFTScreen.rect(40,10,0,90);
  TFTScreen.rect(70,10,0,90);
  TFTScreen.rect(10,40,90,0);
  TFTScreen.rect(10,70,90,0);

  /* initial position */
  TFTScreen.stroke(255,255,255); //white
  TFTScreen.rect(10,10,30,30);

  /* Score */
  TFTScreen.stroke(0,0,255); // red
  TFTScreen.setCursor(115, 50);
  TFTScreen.setTextSize(2);
  TFTScreen.println(winner_o);
  TFTScreen.stroke(0,255,255); // yellow
  TFTScreen.setCursor(115, 80);
  TFTScreen.setTextSize(2);
  TFTScreen.println(winner_x);

  cli();

  // Setare mod de funcționare CTC (Clear Timer on Compare)
  TCCR1A = 0;  // Timer1: mod normal, nu utilizăm pinii OC1A și OC1B
  TCCR1B = (1 << WGM12);

  // Setare prescaler la 256
  TCCR1B |= (1 << CS12);

  // Setare valoare OCR1A pentru generarea întreruperii la fiecare 15 secunde
  OCR1A = 60000;  // Calculat pentru frecvența întreruperii de 1 Hz (1/15 Hz cu prescaler 256)

  // Activare întreruperi pentru compararea cu OCR1A
  TIMSK1 |= (1 << OCIE1A);

  // Activarea întreruperilor globale
  sei();
}

void loop() {
  O_buttonState = digitalRead(2);
  X_buttonState = digitalRead(3);
  down_buttonState = digitalRead(4);
  up_buttonState = digitalRead(5);
  left_buttonState = digitalRead(6);
  right_buttonState = digitalRead(7);
  
  if(is_full == true) {
    delay(2000);
    TFTScreen.background(0,0,0);
    TFTScreen.stroke(255,255,255); //white
    TFTScreen.setCursor(20, 70);
    TFTScreen.setTextSize(2);
    TFTScreen.println("GAME OVER!");
    TFTScreen.setCursor(50, 90);
    TFTScreen.println("TIE");
    reset_game();
  }
  else {
    if(O_buttonState != prev_O) {
      if (O_buttonState == HIGH) {
        if(a[i][j] == 0) {
          contor += 1;
          a[i][j] = 1;
          TFTScreen.stroke(0,0,255); //red
          TFTScreen.setCursor(cursor_x, cursor_y);
          TFTScreen.setTextSize(2);
          TFTScreen.println("O");
          if(check_game_over() != 0) {
            delay(1000);
            TFTScreen.background(0,0,0);
            TFTScreen.stroke(255,255,255); //white
            TFTScreen.setCursor(20, 70);
            TFTScreen.setTextSize(2);
            TFTScreen.println("GAME OVER!");
            TFTScreen.setCursor(25, 90);
            TFTScreen.stroke(0,0,255); //red
            TFTScreen.println("WINNER O");
            winner_o += 1;
            reset_game();
          }
          else 
            delay(1000);
        }
      }
      O_buttonState = prev_O;
    } else if(X_buttonState != prev_X) {
      if (X_buttonState == HIGH) {
        if(a[i][j] == 0) {
          contor += 1;
          a[i][j] = 2;
          TFTScreen.stroke(0,255,255); //yellow
          TFTScreen.setCursor(cursor_x, cursor_y);
          TFTScreen.setTextSize(2);
          TFTScreen.println("X");
          if(check_game_over() != 0) {
            delay(1000);

            TFTScreen.background(0,0,0);
            TFTScreen.stroke(255,255,255); //white
            TFTScreen.setCursor(20, 70);
            TFTScreen.setTextSize(2);
            TFTScreen.println("GAME OVER!");
            TFTScreen.setCursor(25, 90);
            TFTScreen.stroke(0,255,255); //yellow
            TFTScreen.println("WINNER X");
            winner_x += 1;
            reset_game();
          }
          else
            delay(1000);
        }
      }
      X_buttonState = prev_X;
    } else if(down_buttonState != prev_down) {
      if (down_buttonState == HIGH) {
        if(cursor_y < 70 ) {
          j++;
          cursor_y += 30;
          cursor_y2 += 30;
          reset_display();
          TFTScreen.stroke(255,255,255); //white
          TFTScreen.rect(cursor_x2,cursor_y2,30,30);
        }
      }
      prev_down = down_buttonState;
    } else if(right_buttonState != prev_right) {
      if (right_buttonState == HIGH) {
        if(cursor_x < 70) {
          i++;
          cursor_x += 30;
          cursor_x2 += 30;
          reset_display();
          TFTScreen.stroke(255,255,255); 
          TFTScreen.rect(cursor_x2,cursor_y2,30,30);
        }
      }
      prev_right = right_buttonState;
    } else if(left_buttonState != prev_left) {
      if (left_buttonState == HIGH) {
        if(cursor_x > 20) {
          i--;
          cursor_x -= 30;
          cursor_x2 -= 30;
          reset_display();
          TFTScreen.stroke(255,255,255); 
          TFTScreen.rect(cursor_x2,cursor_y2,30,30);
        }
      }
      prev_left = left_buttonState;
    } else if(up_buttonState != prev_up) {
      if (up_buttonState == HIGH) {
        if(cursor_y > 20) {
          j--;
          cursor_y -= 30;
          cursor_y2 -= 30;
          reset_display();
          TFTScreen.stroke(255,255,255);
          TFTScreen.rect(cursor_x2,cursor_y2,30,30);
        }
      }
      prev_up = up_buttonState;
    }
  }
}